library IEEE;
use IEEE.std_logic_1164.all;

entity HEX7SEG is
    port (
        D: in STD_LOGIC_VECTOR (3 downto 0);
        EN: in STD_LOGIC;
        U: out STD_LOGIC_VECTOR (0 to 6)
    );
end HEX7SEG;

architecture HEX7SEG_arch of HEX7SEG is

signal UI: STD_LOGIC_VECTOR (0 to 6);

begin
   U <= UI when (EN='1') else B"1111110";
	
   with D select
--            abcdefg
      UI <= B"0000001" when X"0",
            B"1001111" when X"1",
            B"0010010" when X"2",
            B"0000110" when X"3",
            B"1001100" when X"4",
            B"0100100" when X"5",
            B"0100000" when X"6",
            B"0001111" when X"7",
            B"0000000" when X"8",
            B"0000100" when X"9",
            B"0001000" when X"A",
            B"1100000" when X"B",
            B"0110001" when X"C",
            B"1000010" when X"D",
            B"0110000" when X"E",
            B"0111000" when others;

end HEX7SEG_arch;
